/**
 * Timezone Date Class
 * @param {number|TZDate|Date|string} date - date to be converted
 */
export default class TZDate {
    private tzOffset;
    private d;
    /**
     * Timezone Date Class
     * @param {number|TZDate|Date|string} date - date to be converted
     */
    constructor(...args: any[]);
    toString(): string;
    addFullYear(y: number): TZDate;
    addMonth(m: number): TZDate;
    addDate(d: number): TZDate;
    addHours(h: number): TZDate;
    addMinutes(M: number): TZDate;
    addSeconds(s: number): TZDate;
    addMilliseconds(ms: number): TZDate;
    setWithRaw(y: number, m: number, d: number, h: number, M: number, s: number, ms: number): TZDate;
    toDate(): Date;
    valueOf(): number;
    getTimezoneOffset(): number;
    /**
     * Get milliseconds which is converted by timezone
     * @returns {number} milliseconds
     */
    getTime(): number;
    getFullYear(): number;
    getMonth(): number;
    getDate(): number;
    getHours(): number;
    getMinutes(): number;
    getSeconds(): number;
    getMilliseconds(): number;
    getDay(): number;
    setTime(t: number): number;
    setFullYear(y: number, m?: number, d?: number): number;
    setMonth(m: number, d?: number): number;
    setDate(d: number): number;
    setHours(h: number, M?: number, s?: number, ms?: number): number;
    setMinutes(M: number, s?: number, ms?: number): number;
    setSeconds(s: number, ms?: number): number;
    setMilliseconds(ms: number): number;
    tz(tzValue: string | 'Local' | number): TZDate;
    /**
     * Get the new instance following the system's timezone.
     * If the system timezone is different from the timezone of the instance,
     * the instance is converted to the system timezone.
     *
     * Instance's `tzOffset` property will be ignored if there is a `tzValue` parameter.
     */
    local(tzValue?: string | number): TZDate;
}
